#define _WIN32_DCOM

#include <unknwn.h> // type UUID
#include "../Commun/Fabriques--ServeurPremiers.h"
#include "../../StdOutilsCOM_Lib/registry.h"
#include "FabriqueServeurPremiers.h"


// ----------------------------------------------------
// ----------------------------------------------------
// ----------------------------------------------------
// Fonctions globales pour le DLL (donnent un accs
// opaque aux classes ci-dessus)
// ----------------------------------------------------

HRESULT __stdcall DllCanUnloadNow ()
{
   return GestionnaireDeVerrou::EstVide ();
}

HRESULT __stdcall DllGetClassObject (REFCLSID clsid,
                                     REFIID riid,
                                     void **ppv)
{
   if (clsid != CLSID_FabriqueAnalystePremiers)
      return CLASS_E_CLASSNOTAVAILABLE;

   Fabrique *pFab = new Fabrique ();
   if (!pFab)
      return E_OUTOFMEMORY;

   // riid devrait tre IID_IClassFactory
   HRESULT hr = pFab->QueryInterface (riid, ppv);
   pFab->Release ();
   return hr;
}

static const char
   *SRV_NOMFICH = "inproc_async.dll"
,  *SRV_DESCR   = "Composant in-process de dmonstration asynchrone"
,  *SRV_NOM     = "Component.InProc.Async"
,  *SRV_VERSION = "Component.InProcAsync..1"
;

HRESULT __stdcall DllRegisterServer ()
{
   // Trouver le chemin menant  la DLL
   const int TAILLE_CHEMIN_MAX = 512;
   char Chemin[TAILLE_CHEMIN_MAX];

   HMODULE hModule = GetModuleHandle(SRV_NOMFICH);
	GetModuleFileName(hModule, Chemin, TAILLE_CHEMIN_MAX/sizeof(char));

   // On le met en caractres 16 bits
   wchar_t CheminLarge[TAILLE_CHEMIN_MAX];
   mbstowcs(CheminLarge, Chemin, TAILLE_CHEMIN_MAX);

   ITypeLib *pTypeLib;
   HRESULT hr = LoadTypeLibEx (CheminLarge, REGKIND_REGISTER, &pTypeLib);
   if (FAILED (hr))
      return hr;

   pTypeLib->Release ();

   HRESULT hrSync = RegisterServer (SRV_NOMFICH,
                          CLSID_FabriqueAnalystePremiers,
                          SRV_DESCR,
                          SRV_NOM,
                          SRV_VERSION,
                          0 ); // Threading model: NULL
   return hrSync;
}


HRESULT __stdcall DllUnregisterServer ()
{
   // incomplet; devrait aussi dsinscrire la bibliothque de types
   return UnregisterServer (CLSID_FabriqueAnalystePremiers,
                            SRV_NOM,
                            SRV_VERSION);
}

